# Enum rustc_lexer::LiteralKind

source ·

    pub enum LiteralKind {
        Int {
            base: Base,
            empty_int: bool,
        },
        Float {
            base: Base,
            empty_exponent: bool,
        },
        Char {
            terminated: bool,
        },
        Byte {
            terminated: bool,
        },
        Str {
            terminated: bool,
        },
        ByteStr {
            terminated: bool,
        },
        CStr {
            terminated: bool,
        },
        RawStr {
            n_hashes: Option<u8>,
        },
        RawByteStr {
            n_hashes: Option<u8>,
        },
        RawCStr {
            n_hashes: Option<u8>,
        },
    }

Expand description

Enum representing the literal types supported by the lexer.

Note that the suffix is not considered when deciding the `LiteralKind` in this type. This means that float literals like `1f32` are classified by this type as `Int`. (Compare against `rustc_ast::token::LitKind` and `rustc_ast::ast::LitKind`).

## Variants§

§

### Int

“12_u8”, “0o100”, “0b120i99”, “1f32”.

#### Fields

§`base: Base`
§`empty_int: bool`
§

### Float

“12.34f32”, “1e3”, but not “1f32”.

#### Fields

§`base: Base`
§`empty_exponent: bool`
§

### Char

“‘a’”, “‘\’”, “‘’‘”, “’;”

#### Fields

§`terminated: bool`
§

### Byte

“b’a’”, “b’\‘”, “b’‘’”, “b’;”

#### Fields

§`terminated: bool`
§

### Str

““abc”“, ““abc”

#### Fields

§`terminated: bool`
§

### ByteStr

“b“abc”“, “b“abc”

#### Fields

§`terminated: bool`
§

### CStr

`c"abc"`, `c"abc`

#### Fields

§`terminated: bool`
§

### RawStr

“r“abc”“, “r#“abc”#“, “r####“ab”###“c”####“, “r#“a”. `None` indicates an invalid literal.

#### Fields

§`n_hashes: Option<u8>`
§

### RawByteStr

“br“abc”“, “br#“abc”#“, “br####“ab”###“c”####“, “br#“a”. `None` indicates an invalid literal.

#### Fields

§`n_hashes: Option<u8>`
§

### RawCStr

`cr"abc"`, “cr#“abc”#“, `cr#"a`. `None` indicates an invalid literal.

#### Fields

§`n_hashes: Option<u8>`

## Trait Implementations§

source§

### impl Clone for LiteralKind

source§

#### fn clone(&self) -> LiteralKind

Returns a copy of the value. Read more
1.0.0 · source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
source§

### impl Debug for LiteralKind

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
source§

### impl Ord for LiteralKind

source§

#### fn cmp(&self, other: &LiteralKind) -> Ordering

This method returns an `Ordering` between `self` and `other`. Read more
1.21.0 · source§

#### fn max(self, other: Self) -> Self
where Self: Sized,

Compares and returns the maximum of two values. Read more
1.21.0 · source§

#### fn min(self, other: Self) -> Self
where Self: Sized,

Compares and returns the minimum of two values. Read more
1.50.0 · source§

#### fn clamp(self, min: Self, max: Self) -> Self
where Self: Sized + PartialOrd,

Restrict a value to a certain interval. Read more
source§

### impl PartialEq for LiteralKind

source§

#### fn eq(&self, other: &LiteralKind) -> bool

This method tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0 · source§

#### fn ne(&self, other: &Rhs) -> bool

This method tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
source§

### impl PartialOrd for LiteralKind

source§

#### fn partial_cmp(&self, other: &LiteralKind) -> Option<Ordering>

This method returns an ordering between `self` and `other` values if one exists. Read more
1.0.0 · source§

#### fn lt(&self, other: &Rhs) -> bool

This method tests less than (for `self` and `other`) and is used by the `<` operator. Read more
1.0.0 · source§

#### fn le(&self, other: &Rhs) -> bool

This method tests less than or equal to (for `self` and `other`) and is used by the `<=` operator. Read more
1.0.0 · source§

#### fn gt(&self, other: &Rhs) -> bool

This method tests greater than (for `self` and `other`) and is used by the `>` operator. Read more
1.0.0 · source§

#### fn ge(&self, other: &Rhs) -> bool

This method tests greater than or equal to (for `self` and `other`) and is used by the `>=` operator. Read more
source§

### impl Copy for LiteralKind

source§

### impl Eq for LiteralKind

source§

### impl StructuralPartialEq for LiteralKind

## Auto Trait Implementations§

§

### impl Freeze for LiteralKind

§

### impl RefUnwindSafe for LiteralKind

§

### impl Send for LiteralKind

§

### impl Sync for LiteralKind

§

### impl Unpin for LiteralKind

§

### impl UnwindSafe for LiteralKind

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> CloneToUninit for T
where T: Copy,

source§

#### unsafe fn clone_to_uninit(&self, dst: *mut T)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dst`. Read more
source§

### impl<T> CloneToUninit for T
where T: Clone,

source§

#### default unsafe fn clone_to_uninit(&self, dst: *mut T)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dst`. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> ToOwned for T
where T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 3 bytes

Size for each variant:

- `Int`: 2 bytes
- `Float`: 2 bytes
- `Char`: 1 byte
- `Byte`: 1 byte
- `Str`: 1 byte
- `ByteStr`: 1 byte
- `CStr`: 1 byte
- `RawStr`: 2 bytes
- `RawByteStr`: 2 bytes
- `RawCStr`: 2 bytes